/**
 * DiscreteScaleValues.java
 */
package UTEStatsViewer;
/**
 * Interface implemented by an object that supplies the values of the
 * tick marks of a discrete scale.
 */
public interface DiscreteScaleValues {
   /**
    * Return a value as it is to appear with a scale.
    * @param i the index of the discrete value [0..]
    */
   public abstract String getDiscreteScaleValue(int i)
         throws ArrayIndexOutOfBoundsException;


   /**
    * Return an array of values as they are to appear with a scale.
    */
   public abstract String[] getDiscreteScaleValues();


   /**
    * Return a value as it is to appear in messages.
    * @param i the index of the discrete value [0..]
    */
   public abstract String getDiscreteScaleValueString(int i)
         throws ArrayIndexOutOfBoundsException;


   /**
    * Return an array of values as they are to appear in messages.
    */
   public abstract String[] getDiscreteScaleValueStrings();


   /**
    * Return an array of Named objects whose getName() method returns
    * the scale value as it is to appear in messages.
    */
   public abstract Named[] getDiscreteScaleValueNamed();


   /** Return the number of values. */
   public abstract int size();
}
