
		LIMITED RIGHTS NOTICE 

 (a) These data are submitted with limited rights under Subcontract No.
 B331593 (and lower-tier subcontract, if appropriate). These data may be
 reproduced and used by the University and the Government with the
 express limitation that they will not, without written permission of the
 Subcontractor, be used for purposes of manufacture nor disclosed outside
 the University or the Government; except that the University or the
 Government may disclose these data outside the University or the
 Government for the following purposes, if any; provided that the
 University and the Government makes such disclosure subject to
 prohibition against further use and disclosure*:

 (b) This Notice shall be marked on any reproduction of these data in
 whole or in part.


                       (End of Notice)

 *The purposes shall be identified in the subcontract schedule when this
 clause is used. (1)

 (1) There are none to date.

---------------------------------------------------------------------------



In order to create traces of your application for analysis, you must perform
the following steps

1) Compile your program, linking with the UTE library.
2) Set the appropriate trace options in the TRACEOPT environment variable
   including the name of the trace files.
3) Run your application program.
4) Gather all trace files into a single directory.
5) Convert the AIX trace files using the convert utility.
6) Merge the convert files into a single SLOG file.
7) Visualize the contents of the file using Jumpshot.

Step 1:
-----------

For this example, assume a user, testuser, has a home directory /u/testuser
and that UTE has been installed so that it's top level directory is
/u/testuser/ute.

C Programs must be compiled using the mpcc_r command. FORTRAN programs must
be compiled with the mpxlf_r command. In both cases, you must specify the
following flags to these commands in addition to those that you usually specify.

 -L <Full libute.a path> -l ute -l swclock -l rts

For instance, to compile a C program, mytest.c, use the command

 mpcc_r -o mytest mytest.c -L /u/testuser/ute/lib -l ute -l swclock -l rts



Step 2:
-------

When your program is run, it will create one trace file per node. You must
specify a prefix which will be used in generating the pathnames for each trace
file.

The trace files should reside in a filesystem which is local to each node. 
If the trace file is written to a networked filesystem, such as NFS, the
delays associated with networked file systems may cause the AIX trace buffer to
wrap, which will invalidate the trace files.

The path name specified in this prefix must be consistent across all nodes.
For instance, if each node has a local filesystem named /scratch, then you
could specify the prefix as '/scratch/mytrace.'.

When the trace files are created, the task number of the task that created
the trace file is appended to the specified prefix. A program which ran on four
nodes would generate four trace files, named /scratch/mytrace.0,
/scratch/mytrace.1, /scratch.mytrace.2, and /scratch/mytrace.3.

Before you run your program, you need to set an environment variable, TRACEOPT
to specify the trace options. The options are described below.

  -o <trace file prefix>
     This option specifies the prefix for each individual trace filename as
     described above. This option is the only mandatory option.

  -j <trace event codes>
     This option specifies the trace events to be recorded in the trace files. 
     Currently, the only event code supported is 106, which is used to record
     active process and thread dispatch events. You do not need to specify any
     trace event code to capture MPI trace events. 

  -T <trace buffer size> 
     To change the amount of pinned memory allocated to the trace buffers. 
     Larger values reduce the possibility of trace buffer overflow, but 
     require more memory. You cannot set the trace buffer size larger than 1MB.

  -L <trace file size limit>
     Specifies the maximum size of each trace file, in bytes.

  -d 
     Defers starting the trace until the first time MPI_Pcontrol is called to
     enable tracing any MPI call. 

For example, assuming you are using ksh, you can set TRACEOPT with the command

  export TRACEOPT='-o /scratch/mytrace. -T 1000000 -L 20000000'


Step 3:
--------

Run your application.

Step 4:
--------

After your program has run, you need to collect all trace files for this run 
into a single directory. This directory should contain only the trace files 
from this run, and no trace files from previous runs. One way to collect these
trace files is to use the dsh command. Assuming you have set the WCOLL
environment variable to the list of nodes where trace files reside, and you
want to collect all tracefiles into a directory /u/testuser/traces, use the
command

  dsh cp '/scratch/mytrace.*' /u/testuser/traces

At this point, you are ready to run the convert program.

Step 5:
-----------

Convert a number of AIX trace files to UTE interval files.

You need to have the etc/profile.ute file either in this same directory
where you store your trace files, or use the -p option on the
convert and utemerge program to specify the path to this file.

The convert program converts a set of AIX trace files into UTE interval
files.  It converts one AIX file at a time.  If the "-r" option is
specified, the AIX trace file will be deleted at the end of the conversion
for each trace file to reduce the need for disk space.

Usage: convert -[#?r] [-n #_files] [-p profile] [-c #_records_per_frame] [-f #_f
rames_per_dir] [-o outfile_prefix] infile_prefix

-# or -?               Usage
-r                     Remove input AIX trace file after conversion
-n #_files             Specify the number of files to be converted (default=1)
                       if #_files is 1, the prefix is the file name
-p profile             Specify profile (default=profile.ute)
-c #_records_per_frame Specify number of records per frame (default=20000)
-f #_frames_per_dir    Specify number of frames per frame directory (default=8)
-o outfile_prefix      Specify output file prefix or output file name
infile_prefix          Specify input file prefix

Example:

Assuming that the convert program is in your PATH.

1. Suppose a set of AIX trace files, sppm.[0123], have been generated and
exist in the current directory along with the binary profile.ute file.
Issue the command to convert the AIX trace file sppm.[0123] into UTE interval
files sppm_ute.[0123]:

% convert -n4 -o sppm_ute. sppm.

2. If you have tight space in the current file system and don't need the 
AIX trace files anymore after the conversion, use the "-r" option:

% convert -r -n4 -o sppm_ute. sppm.

NOTE: Do not use the "-r" option if you would like to keep the AIX trace files.


Step 6:
----------

Merge a number of UTE interval files to one SLOG file.

The utemerge program merges a set of UTE interval files into one SLOG file.
A binary profile, which defaults to profile.ute in the current
directory, is required to decode the UTE interval files.
If the profile is not in the current directory, the "-p profile_name"
option should be used to locate the profile.

The program merges multiple UTE interval files based on global clock records,
which were captured during the execution.  If there are no global clock records
in an input file, a warning message will be shown and that file will not be 
merged into the SLOG file.  

The program calls the SLOG library to create the output SLOG file and
append one interval at a time.  If the option "-u" is specified, the program
generates the output in UTE interval format, same as that of its input files.

usage: utemerge [-?#] [-n #_nodes] [-p profile] [-m #_markers] [-c number] [-u
[-f #_frames]] [-o out_file] in_prefix
-? or -#       Usage
-n #_nodes     Specify the number of nodes (defaults to 1)
-m #_markers   Specify the maximum number of user markers in SLOG (default=20)
-p profile     Specify the binary profile (defaults to profile.ute)
-o out_file    Specify output file name
-c number      Specify the number of bytes in a SLOG frame (default=131072)
                 or the number of records in a UTE frame (with -u option)
-u             Specify UTE interval format for output (default=SLOG format)
-f #_frames    Specify the number of frames per directory (with -u option)
in_prefix      Specify input file name prefix

Restriction: the "-s range" option is currently not available and
will be implemented in future versions.

Example:

Assuming that the utemerge program is in your PATH.

1. Suppose a set of UTE trace files, sppm_ute.[0123], have been generated and
exist in the current directpory along with the binary profile.ute file.
Issue the command to merge the UTE interval files sppm_ute.[0123] into one
SLOG file sppm.slog:

% utemerge -n4 -o sppm.slog sppm_ute.

2. If the binary profile.ute is somewhere else, say in the parent directory,
issue the command with "-p profile_name" option to specify the profile:

% utemerge -p ../profile.ute -n4 -o sppm.slog sppm_ute.


Step 7:
--------

Use Jumpshot to visualize the slog file.

--------------------------------------------------------------------------------

If you want to view the statistical data for a set of trace files, then you 
must perform the following steps, using either the set of flies generated
by the convert utility in step 5 above, or the slog file generated by running
the utemerge utility with the -u option. Generating the slog file is only 
required if you need to view statistics where the system clock has been
synchronized across all nodes.

1) Run the utestats program to generate the statistics file. This statistics 
   file can be read by the statistics viewer program included with the
   Jumpshot distribution, or can be imported into a spreadsheet program as a
   text file. See README.utestats for details. The input to this program is
   the interval files or slog file as described above.
2) View the statistical data by starting the statistics viewer program from
   within Jumpshot, or by running a spreadsheet program. See README.viewstats
   for instructions on using the viewer, and the Jumpshot documentation for
   instructions on running the viewer.
